.. half_band_interpolator_xs documentation

.. This file is protected by Copyright. Please refer to the COPYRIGHT file
   distributed with this source distribution.

   This file is part of OpenCPI <http://www.opencpi.org>

   OpenCPI is free software: you can redistribute it and/or modify it under the
   terms of the GNU Lesser General Public License as published by the Free
   Software Foundation, either version 3 of the License, or (at your option) any
   later version.

   OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
   more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.


.. _half_band_interpolator_xs:


Half Band Interpolator (``half_band_interpolator_xs``)
======================================================
An interpolating finite impulse response (FIR) filter, which makes use of the symmetries in the taps and interpolating factor of 2, to allow a more efficient implementation.

Design
------
A half band interpolating filter is a specialised case of FIR filter design which has an interpolating factor of 2. This results in a filter with an odd number of taps, with symmetry around the central tap, and all odd taps (except the central tap) being zero-valued. The zero taps may be skipped from the multiply accumulation, increasing the efficiency of the symmetric filter, with only a quarter of the number of multiplications required when compared to a normal FIR filter.

The basis of a symmetric FIR filter are described in :ref:`fir_filter_symmetric_xs`.

As a half band interpolating filter interpolates by 2, the maximum passband specification is with the transition zone being at :math:`\frac{F_s}{4}` (where :math:`F_s` is the sampling frequency). This leads to every second coefficient equalling zero (and therefore capable of being skipped from the multiply accumulation).

.. math::
   :label: half_band_interpolating_FIR_xs-equation

   y(n) = \left( \sum_{k=0}^\frac{N-3}{4} h[2k] \times (x[n-2k]+x[n-N+2k])\right) + h[\frac{N-1}{2}] \times x[n-\frac{N-1}{2}]

In :eq:`half_band_interpolating_FIR_xs-equation`:

 * :math:`y[n]` is the output values.

 * :math:`x[n]` is the input values.

 * :math:`N` is the total number of taps.

 * :math:`h[k]` is the taps values, from :math:`0` to :math:`N - 1`.

The equation :eq:`half_band_interpolating_FIR_xs-equation`, results in folding of :math:`h(k)` taps around :math:`N/2`, and skipping every second calculation of :math:`h * x`, resulting in a quarter of the multiplications and additions that would have been required by a generalized FIR as shown in :ref:`fir_filter_symmetric_xs`. This structure is shown in :numref:`half_band_interpolator-diagram`.

.. _half_band_interpolator-diagram:

.. figure:: half_band_interpolator.svg
   :alt: Block diagram showing half band interpolator FIR structure.
   :align: center

   Half band interpolator FIR structure.

As the calculation involves rounding, there is a choice of rounding types that can be selected via the ``rounding_type`` property. The application should choose between half-up, half-even or truncation to minimise any bias. The truncation also has a choice to saturate the output generated by the component to the maximum or minimum value defined by the output type (e.g. -32,768 to 32,767 for short values). This can be achieved by using the ``truncate_with_saturation`` value.

References
~~~~~~~~~~

 * https://www.dsprelated.com/showarticle/1113.php

 * https://www.dsprelated.com/showcode/270.php

 * https://tomverbeure.github.io/2020/12/15/Half-Band-Filters-A-Workhorse-of-Decimation-Filters.html

 * W. Cho, D. Chung, Y. Kim, I. Kim and J. Jeon, "Design of FIR Half-Band Filter With Controllable Transition-Band Steepness," in IEEE Access, vol. 9, pp. 52144-52154, 2021, doi: 10.1109/ACCESS.2021.3069985. https://ieeexplore.ieee.org/document/9391655

.. spelling:word-list::
   Cho
   Jeon
   doi

Interface
---------
.. literalinclude:: ../specs/half_band_interpolator_xs-spec.xml
   :language: xml
   :lines: 1,19-

Opcode Handling
~~~~~~~~~~~~~~~

   * Samples

      * Insert zeroes between every sample.

      * Apply the samples to the FIR cascade structure.

      * Send the calculated samples to the output port.

   * Time

      * The time is decremented by the ``group_delay`` before forwarding to output port.

   * Sample_Interval

      * The output sample interval is calculated as the input sample interval divided by 2.

   * Flush

      * Input ``number_of_taps`` zeros into the sample buffer, outputting any samples generated.

      * Forward to output port.

   * Discontinuity

      * Reset history buffer.

      * Forward to output port.

   * Metadata

      * Forward to output port.


Properties
~~~~~~~~~~
.. ocpi_documentation_properties::

Ports
~~~~~
.. ocpi_documentation_ports::

   input: Primary input samples port.
   output: Primary output samples port.

Implementations
---------------
.. ocpi_documentation_implementations:: ../half_band_interpolator_xs.rcc ../half_band_interpolator_xs.hdl

Example Application
-------------------
.. literalinclude:: example_app.xml
   :language: xml
   :lines: 1,19-

Dependencies
------------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/dependencies.inc

   |primitive_name|: Protocol interface FIFO primitive v2
   |primitive_link|: protocol_interface_fifo_v2-primitive

Limitations
-----------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/limitations.inc

   |component_name|: half_band_interpolator_xs

Both implementations require the property ``number_of_taps`` to be set to a value which adheres to:

   :math:`N = (4n - 1)`.

   Where: N is the ``number_of_taps``, and :math:`n` is any positive number.

   Taps must be symmetrical with all odd taps (except the central tap) being zero-valued.


Testing
-------
.. ocpi_documentation_test_platforms::

.. ocpi_documentation_test_result_summary::
